#ifndef _CQUEUE_H
#define _CQUEUE_H

#include <string.h>
#include "mutex.h"

#define QUEUE_DEFAULT_SIZE     256*1024

class CQueue
{
  private:
    int size;
    long int num_data;
    long int read_pointer;
    long int write_pointer;
    unsigned char *data;
    CMutex queue_access;
  public:
    CQueue();
    CQueue(int size);
    void resize(int new_size);
    int read(unsigned char *data,int len);
    int write(unsigned char *data,int len);
    int get_num_data(void);
    bool is_empty(void);
    bool is_full(void);
    void flush(void);
    ~CQueue();
};

#endif
